/*
 * base64.c
 * MIME base64 (RFC 1341) encode
 * Copyright (C) October, 1998 Sergei Viznyuk <sv@phystech.com>
 * this code has been derived from a code by
 * Artur Skawina <skawina@usa.net>
 * http://www.ml.org/ml/dyndns/clients.html
 * 
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
  
static const unsigned char BaseTable[] =
                           "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
                           "abcdefghijklmnopqrstuvwxyz"
                           "0123456789+/";

/*****************************************************************************/
unsigned benc(dst,src,slen)
unsigned char *dst,*src;
unsigned slen;
{
  unsigned m = slen%3;
  unsigned k = slen-m;
  register unsigned i = 0;
  register unsigned d = 0;

  while ( i < k )
    {
      dst[d++] = BaseTable[((src[i] & 0xFC) >> 2)];
      dst[d++] = BaseTable[(((src[i] & 0x03) << 4) | ((src[i+1] & 0xF0) >> 4))];
      dst[d++] = BaseTable[(((src[i+1] & 0x0F) << 2) | ((src[i+2] & 0xC0) >> 6))];
      dst[d++] = BaseTable[(src[i+2] & 0x3F)];
      i += 3;
    }
  switch (m)
    {
      case 2:
        dst[d++] = BaseTable[((src[k] & 0xFC) >> 2)];
        dst[d++] = BaseTable[(((src[k] & 0x03) << 4) | ((src[k+1] & 0xF0) >> 4))];
        dst[d++] = BaseTable[((src[k+1] & 0x0F) << 2)]; 
        break;
      case 1:
        dst[d++] = BaseTable[((src[k] & 0xFC) >> 2)];
        dst[d++] = BaseTable[((src[k] & 0x03) << 4)];
      default:
    }
  while (d%3) dst[d++] = '=';
  dst[d] = 0;
  return d;
}
/*****************************************************************************/
#if 0
main(int argn, char *argc[] )
{
   char src[4096],dst[4096];
   int slen,dlen;
   slen=sprintf(src,"%s:%s",argc[1],argc[2]);
   dlen=benc(dst,src,slen);
   fprintf(stdout,"src=\"%s\" slen=%d dst=\"%s\" dlen=%d\n",src,slen,dst,dlen); 
}
#endif
