/*
 * signals.c
 * Copyright (C) January, 1998 Sergei Viznyuk <sv@phystech.com>
 * 
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <sys/types.h>
#include <stdio.h>
#include <unistd.h>
#include <syslog.h>
#include <signal.h>
#include "mlip.h"

extern char		*ProgramName;
extern int		IsTTY;

/*****************************************************************************/
void sigHandler(sig)
int sig;
{
  if ( sig == SIGALRM )
    {
      if ( IsTTY )
	fprintf(stderr,"%s: timed out connecting to "URLHOST"\n",ProgramName);
      else
	syslog(LOG_ERR,"timed out connecting to "URLHOST"\n");
    }
  else
    {
      if ( IsTTY )
        fprintf(stderr,"%s: terminating on signal %d\n",ProgramName,sig);
      else
        syslog(LOG_ERR,"terminating on signal %d\n",sig);
    }
  exit(sig);
}
/*****************************************************************************/
void signalSetup()
{
  int i;
  struct sigaction action;
  sigaction(SIGHUP,NULL,&action);
  action.sa_handler= &sigHandler;
  action.sa_flags = 0;
  for (i=1;i<16;i++) sigaction(i,&action,NULL);
}
